/*
 * (C) Maint Laboratory 2000-2007
 * Author: Elohin Igor'
 * e-mail: maint@unona.ru
 * fido  : 2:5070/156.52
 * URL   : http://maint.unona.ru
 */
/*
 *  lock-   
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <unistd.h>
#include <fcntl.h>
#if _WIN32 || MSDOS
#include <io.h>
#endif

int lock_file(char *fname)
{
    int fd;
    char buf[128];
    pid_t pid;

    if (access(fname, F_OK) == 0)
	return -1;
    if ((fd = open(fname, O_RDWR | O_CREAT | O_TRUNC | O_EXCL, 0600)) < 0)
	return -1;
    pid = getpid();
    sprintf(buf, "%d", pid);
    write(fd, buf, strlen(buf));
    return fd;
}

int remove_lock(int fd, char *fname)
{
    char buf[128];
    char *s;
    pid_t pid;

    if (access(fname, F_OK) < 0)
	return -1;
    pid = getpid();
    lseek(fd, SEEK_SET, 0);
    if(read(fd, buf, 128) <= 0){
        return -1;
    }
    if((s = strchr(buf, '\n')) == NULL)
        *s = '\0';
    if(atol(buf) == pid){
        close(fd);
        return remove(fname);
    } else
        return -1;
}
